(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react'), require('prop-types'), require('history'), require('react-router-dom'), require('react-preload-core')) :
	typeof define === 'function' && define.amd ? define(['exports', 'react', 'prop-types', 'history', 'react-router-dom', 'react-preload-core'], factory) :
	(factory((global.ReactRouterPreload = {}),global.React,global.PropTypes,global.History,global.ReactRouterDOM,global.ReactPreloadCore));
}(this, (function (exports,React,PropTypes,history,reactRouterDom,reactPreloadCore) { 'use strict';

React = React && React.hasOwnProperty('default') ? React['default'] : React;
PropTypes = PropTypes && PropTypes.hasOwnProperty('default') ? PropTypes['default'] : PropTypes;

var Wrapper = function Wrapper(_ref) {
  var children = _ref.children;
  return children;
};

function preloadRoute(location, component, options) {
  var context = {};
  var element = React.createElement(
    reactRouterDom.StaticRouter,
    { location: location, context: context },
    React.createElement(
      Wrapper,
      null,
      component
    )
  );

  return reactPreloadCore.walkTreeAndPreload(element, {}, true, options).then(function () {
    // In case of a redirect we need to also preload the next route.
    if (typeof context.url !== 'undefined' && typeof context.url === 'string') {
      return preloadRoute(context.url, component, options);
    }
  });
}

var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};









var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};



var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};









var objectWithoutProperties = function (obj, keys) {
  var target = {};

  for (var i in obj) {
    if (keys.indexOf(i) >= 0) continue;
    if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
    target[i] = obj[i];
  }

  return target;
};

var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};

function makeAsyncRouter(BaseComponent) {
  var AsyncRouter = function (_React$Component) {
    inherits(AsyncRouter, _React$Component);

    function AsyncRouter() {
      var _temp, _this, _ret;

      classCallCheck(this, AsyncRouter);

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return _ret = (_temp = (_this = possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.state = {
        match: _this.context.router.route.match,
        location: _this.context.router.history.location,
        transitioning: false,
        next: undefined
      }, _this.loading = {}, _this.preload = function (location) {
        var history$$1 = _this.context.router.history;


        var target = typeof location === 'string' ? history.createLocation(location, null, null, history$$1.location) : location;

        var href = history$$1.createHref(target);
        if (_this.loading.hasOwnProperty(href)) {
          return _this.loading[href];
        }

        return _this.loading[href] = preloadRoute(target, _this.props.children).then(function () {
          delete _this.loading[href];
        });
      }, _temp), possibleConstructorReturn(_this, _ret);
    }

    AsyncRouter.prototype.getChildContext = function getChildContext() {
      return {
        router: _extends({}, this.context.router, {
          transitioning: this.state.transitioning,
          preload: this.preload,
          route: _extends({}, this.context.router.route, {
            location: this.state.location,
            match: this.state.match
          })
        })
      };
    };

    AsyncRouter.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps, nextContext) {
      var _this2 = this;

      var createHref = this.context.router.history.createHref;

      var nextLocation = nextContext.router.route.location;
      var nextHref = createHref(nextLocation);
      var nextMatch = nextContext.router.route.match;
      var currentLocation = this.state.location;
      var currentHref = createHref(currentLocation);

      // Check if we are already on the target route.
      if (nextHref === currentHref) {
        return;
      }

      // Check if we are already transitioning to the target route.
      if (this.state.next && nextHref === createHref(this.state.next)) {
        return;
      }

      // Store the target location to prevent subsequent / queued up route
      // changes from causing hick-ups when triggering location changes
      // quickly.
      this.setState({ next: nextLocation, transitioning: true });

      // Load the target route in the background. Delay the transition
      // until the promise has been resolved.
      this.preload(nextLocation).then(function () {
        _this2.setState(function (prevState) {
          if (nextHref !== createHref(prevState.next)) {
            return null;
          }

          return {
            location: nextLocation,
            match: nextMatch,
            next: undefined,
            transitioning: false
          };
        });
      });
    };

    AsyncRouter.prototype.render = function render() {
      return React.Children.only(this.props.children);
    };

    return AsyncRouter;
  }(React.Component);

  AsyncRouter.contextTypes = {
    router: PropTypes.object.isRequired
  };
  AsyncRouter.childContextTypes = {
    router: PropTypes.object.isRequired
  };


  return function (_ref) {
    var children = _ref.children,
        props = objectWithoutProperties(_ref, ['children']);
    return React.createElement(
      BaseComponent,
      props,
      React.createElement(
        AsyncRouter,
        null,
        children
      )
    );
  };
}

function withAsyncRouter(BaseComponent) {
  var _class, _temp;

  return _temp = _class = function (_React$Component) {
    inherits(WithLoadingState, _React$Component);

    function WithLoadingState() {
      classCallCheck(this, WithLoadingState);
      return possibleConstructorReturn(this, _React$Component.apply(this, arguments));
    }

    WithLoadingState.prototype.render = function render() {
      var _ref = this.context.router || {},
          _ref$transitioning = _ref.transitioning,
          transitioning = _ref$transitioning === undefined ? false : _ref$transitioning,
          _ref$preload = _ref.preload,
          preload = _ref$preload === undefined ? function () {
        return null;
      } : _ref$preload;

      return React.createElement(BaseComponent, _extends({}, this.props, {
        transitioning: transitioning,
        preload: preload
      }));
    };

    return WithLoadingState;
  }(React.Component), _class.contextTypes = {
    router: PropTypes.shape({
      transitioning: PropTypes.bool.isRequired,
      preload: PropTypes.func.isRequired
    })
  }, _temp;
}

var Preload = function (_React$Component) {
  inherits(Preload, _React$Component);

  function Preload() {
    classCallCheck(this, Preload);
    return possibleConstructorReturn(this, _React$Component.apply(this, arguments));
  }

  Preload.prototype.componentDidMount = function componentDidMount() {
    this.context.router.preload(this.props.location);
  };

  Preload.prototype.render = function render() {
    return null;
  };

  return Preload;
}(React.Component);
Preload.contextTypes = {
  router: PropTypes.shape({
    preload: PropTypes.func.isRequired
  })
};

exports.makeAsyncRouter = makeAsyncRouter;
exports.withAsyncRouter = withAsyncRouter;
exports.preloadRoute = preloadRoute;
exports.Preload = Preload;

Object.defineProperty(exports, '__esModule', { value: true });

})));
