var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import { createLocation } from 'history';
import { preloadRoute } from './preloadRoute';

export function makeAsyncRouter(BaseComponent) {
  var AsyncRouter = function (_React$Component) {
    _inherits(AsyncRouter, _React$Component);

    function AsyncRouter() {
      var _temp, _this, _ret;

      _classCallCheck(this, AsyncRouter);

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.state = {
        match: _this.context.router.route.match,
        location: _this.context.router.history.location,
        transitioning: false,
        next: undefined
      }, _this.loading = {}, _this.preload = function (location) {
        var history = _this.context.router.history;


        var target = typeof location === 'string' ? createLocation(location, null, null, history.location) : location;

        var href = history.createHref(target);
        if (_this.loading.hasOwnProperty(href)) {
          return _this.loading[href];
        }

        return _this.loading[href] = preloadRoute(target, _this.props.children).then(function () {
          delete _this.loading[href];
        });
      }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    AsyncRouter.prototype.getChildContext = function getChildContext() {
      return {
        router: _extends({}, this.context.router, {
          transitioning: this.state.transitioning,
          preload: this.preload,
          route: _extends({}, this.context.router.route, {
            location: this.state.location,
            match: this.state.match
          })
        })
      };
    };

    AsyncRouter.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps, nextContext) {
      var _this2 = this;

      var createHref = this.context.router.history.createHref;

      var nextLocation = nextContext.router.route.location;
      var nextHref = createHref(nextLocation);
      var nextMatch = nextContext.router.route.match;
      var currentLocation = this.state.location;
      var currentHref = createHref(currentLocation);

      // Check if we are already on the target route.
      if (nextHref === currentHref) {
        return;
      }

      // Check if we are already transitioning to the target route.
      if (this.state.next && nextHref === createHref(this.state.next)) {
        return;
      }

      // Store the target location to prevent subsequent / queued up route
      // changes from causing hick-ups when triggering location changes
      // quickly.
      this.setState({ next: nextLocation, transitioning: true });

      // Load the target route in the background. Delay the transition
      // until the promise has been resolved.
      this.preload(nextLocation).then(function () {
        _this2.setState(function (prevState) {
          if (nextHref !== createHref(prevState.next)) {
            return null;
          }

          return {
            location: nextLocation,
            match: nextMatch,
            next: undefined,
            transitioning: false
          };
        });
      });
    };

    AsyncRouter.prototype.render = function render() {
      return React.Children.only(this.props.children);
    };

    return AsyncRouter;
  }(React.Component);

  AsyncRouter.contextTypes = {
    router: PropTypes.object.isRequired
  };
  AsyncRouter.childContextTypes = {
    router: PropTypes.object.isRequired
  };


  return function (_ref) {
    var children = _ref.children,
        props = _objectWithoutProperties(_ref, ['children']);

    return React.createElement(
      BaseComponent,
      props,
      React.createElement(
        AsyncRouter,
        null,
        children
      )
    );
  };
}