import React from 'react';
import { StaticRouter } from 'react-router-dom';
import { walkTreeAndPreload } from 'react-preload-core';

var Wrapper = function Wrapper(_ref) {
  var children = _ref.children;
  return children;
};

export function preloadRoute(location, component, options) {
  var context = {};
  var element = React.createElement(
    StaticRouter,
    { location: location, context: context },
    React.createElement(
      Wrapper,
      null,
      component
    )
  );

  return walkTreeAndPreload(element, {}, true, options).then(function () {
    // In case of a redirect we need to also preload the next route.
    if (typeof context.url !== 'undefined' && typeof context.url === 'string') {
      return preloadRoute(context.url, component, options);
    }
  });
}